(window.webpackJsonp=window.webpackJsonp||[]).push([[41],{"./flow-runner/components/_base/AutoScrollUtil.ts":function(e,t,r){"use strict";function n(e,t){if(e&&t){const r=e.getBoundingClientRect(),n=t.getBoundingClientRect();r.bottom>n.bottom&&(t.scrollTop=t.scrollTop+r.bottom-n.bottom+4),r.y<n.y&&(t.scrollTop=t.scrollTop-n.y+r.y-4)}}r.r(t),r.d(t,"autoScroll",(function(){return n}))},"./flow-runner/components/_base/TypeExplorer.tsx":function(e,t,r){"use strict";r.r(t),r.d(t,"MTypeToType",(function(){return O})),r.d(t,"iPathToString",(function(){return I})),r.d(t,"FRIENDLY_TYPE",(function(){return S})),r.d(t,"TypeExplorerSearchEmptyState",(function(){return N}));var n=r("../../node_modules/mobx-react/dist/mobx-react.module.js"),s=r("../../node_modules/react/index.js"),i=r.n(s),o=r("./node_modules/lodash/lodash.js"),a=r("./node_modules/json-pointer/index.js"),p=r("../../node_modules/@postman/aether/esmLib/index.js"),c=r("../../node_modules/@postman/aether-icons/esmLib/index.js"),l=r("../../node_modules/styled-components/dist/styled-components.browser.esm.js"),u=r("../../node_modules/mobx/lib/mobx.module.js"),y=r("./node_modules/classnames/index.js"),m=r.n(y),h=r("./flow-runner/merlin-types/index.ts"),d=r("./flow-runner/components/_base/AutoScrollUtil.ts"),b=r("./flow-runner/merlin-compiler/parser.ts"),f=function(e,t,r,n){var s,i=arguments.length,o=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,r,n);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(o=(i<3?s(o):i>3?s(t,r,o):s(t,r))||o);return i>3&&o&&Object.defineProperty(t,r,o),o},T=function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var s=0;for(n=Object.getOwnPropertySymbols(e);s<n.length;s++)t.indexOf(n[s])<0&&Object.prototype.propertyIsEnumerable.call(e,n[s])&&(r[n[s]]=e[n[s]])}return r};const g=pm.logger.getContext("frontend:base","flows"),O=e=>{if(Object(h.isBasicType)(e))switch(e.type){case"bool":return b.Type.BOOL;case"symbol":return b.Type.SYMBOL;case"number":return b.Type.NUMBER;case"timestamp":return b.Type.TIME;case"regex":return b.Type.REGEX;case"string":return b.Type.STRING;default:return b.Type.ANY}return Object(h.isListType)(e)?b.Type.LIST:Object(h.isTupleType)(e)?b.Type.TUPLE:Object(h.isDictType)(e)?b.Type.MAP:Object(h.isRecordType)(e)||Object(h.isDiscriminatorType)(e)||Object(h.isProductType)(e)?b.Type.RECORD:b.Type.ANY},v=l.default.div`
    display: flex;
    height: 28px;
    padding: 0 ${({theme:e})=>e["spacing-m"]};
    user-select: none;
    cursor: pointer;

    &.isActive {
      background-color: ${({theme:e})=>e["highlight-background-color-secondary"]};
    }
  `,j=l.default.div`
    height: ${({theme:e})=>e["size-xs"]};
    width: ${({theme:e})=>e["size-xs"]};
  `,E=l.default.div`
    display: flex;

    &:hover {
      background: ${e=>e.theme["background-color-secondary"]};
    }
  `,x=l.default.div`
    height: 100%;
    width: ${({theme:e})=>e["spacing-s"]};
    border-left: 1px solid  ${({theme:e})=>e["border-color-default"]};
    margin-left: ${({theme:e})=>e["spacing-s"]};
    box-sizing: border-box;
 `,w=Object(l.default)(p.Text)`
    background-color: ${({theme:e})=>e["background-color-warning"]};
  `,A=Object(l.default)(p.TextInput)`
    padding: ${({theme:e})=>e["spacing-xs"]};
    width: 64px;

    input {
    padding-right: 0px;
}
`,R=(e,t,r,n,s=!1,i=!1,a=!1)=>{if(!t)return[];if(Object(h.isBasicType)(t))return[{name:e,type:O(t),depth:r,path:n,isOptional:s,isMapKey:i,isIndexKey:a}];if(Object(h.isRecordType)(t)){const p={name:e,type:b.Type.RECORD,hasChildren:!0,depth:r,path:n,isOptional:s,isMapKey:i,isIndexKey:a},c=Object.entries(t.properties||{}).map((([e,t],s)=>R(e,t||{},r+1,`${n}.${s}`,!1,!1,!1)));return[p].concat(...Object(o.flatten)(c))}if(Object(h.isTupleType)(t)){const p={name:e,type:b.Type.TUPLE,hasChildren:!0,depth:r,path:n,isOptional:s,isMapKey:i,isIndexKey:a},c=t.items.map(((e,t)=>R(`${t}`,e||{},r+1,`${n}.${t}`,!1,!1,!1)));return[p].concat(...Object(o.flatten)(c))}return Object(h.isDictType)(t)?[{name:e,type:b.Type.MAP,hasChildren:!0,depth:r,path:n,isOptional:s,isMapKey:i,isIndexKey:a},...R("{key}",t.values||{},r+1,`${n}.0`,!1,!0,!1)]:Object(h.isListType)(t)?[{name:e,type:b.Type.LIST,hasChildren:!0,depth:r,path:n,isOptional:s,isMapKey:i,isIndexKey:a},...R("{index}",t.elements,r+1,`${n}.0`,!1,!1,!0)]:Object(h.isDiscriminatorType)(t)?R(e,h.TypeSystem.reduceDiscriminator(t,h.TypeSystem.or),r,n,s,i,a):Object(h.isProductType)(t)?R(e,h.TypeSystem.or(t.product),r,n,s,i,a):Object(h.isVariableType)(t)||Object(h.isAnyType)(t)?[{name:e,type:b.Type.ANY,depth:r,path:n,isOptional:s,isMapKey:i,isIndexKey:a}]:[]},I=e=>e.reduce(((e,t)=>`${e}/${Object(a.escape)(t.name)}`),""),S={[b.Type.BOOL]:"Bool",[b.Type.STRING]:"String",[b.Type.TIME]:"Time",[b.Type.NUMBER]:"Number",[b.Type.SYMBOL]:"Symbol",[b.Type.REGEX]:"Regex (.*)",[b.Type.RECORD]:"Record{}",[b.Type.MAP]:"Dictionary{}",[b.Type.LIST]:"List[]",[b.Type.TUPLE]:"Tuple[]",[b.Type.ANY]:"Ambiguous ∅"},N=()=>i.a.createElement(p.Flex,{padding:"spacing-xs spacing-l"},i.a.createElement(p.Text,{type:"body-medium",color:"content-color-tertiary"},"No results found for the input received")),P=({name:e,type:t,path:r,editable:n=!1,hasChildren:s=!1,collapsed:o=!1,isMapKey:a=!1,isIndexKey:l=!1,isOptional:u=!1,highlight:y=!1,updatePathKeys:m,pathKey:h,onCollapse:d})=>i.a.createElement(p.Flex,{alignItems:"center",grow:1},s?i.a.createElement(E,{onClick:e=>{e.stopPropagation(),e.nativeEvent.stopImmediatePropagation(),d(r)}},(e=>e?i.a.createElement(c.Icon,{name:"icon-direction-right",color:"content-color-secondary"}):i.a.createElement(c.Icon,{name:"icon-direction-down",color:"content-color-secondary"}))(o)):i.a.createElement(j,null),i.a.createElement(p.Flex,{gap:"spacing-s",padding:"spacing-zero spacing-xs",grow:1,width:`calc(100% - ${u?120:48}px)`,alignItems:"center"},(a||l)&&i.a.createElement("div",{onClick:e=>{e.stopPropagation()}},i.a.createElement(A,{placeholder:a?"Key":"Index",value:a?h:h||"0",type:a?"text":"number",size:"small",min:0,onChange:e=>{m(e.target.value)}}))||(y?i.a.createElement(w,{isTruncated:!0},e):i.a.createElement(p.Text,{isTruncated:!0},e)),i.a.createElement(p.Text,{color:"content-color-tertiary"},S[t])),u?i.a.createElement(p.Badge,{text:"optional"}):null,n?i.a.createElement(p.Button,{type:"tertiary",size:"small",icon:"icon-action-edit-stroke"}):null),D=e=>{var{depth:t=0,path:r,onClick:n,isDisabled:s,isActive:a=!1}=e,p=T(e,["depth","path","onClick","isDisabled","isActive"]);return i.a.createElement(v,{onClick:()=>{!s&&n(r,!!p.hasChildren)},className:m()({isActive:a})},Object(o.times)(t,(e=>i.a.createElement(x,{key:e}))),i.a.createElement(P,Object.assign({},p,{path:r,updatePathKeys:p.updatePathKey,pathKey:p.pathKey})))};let L=class extends s.Component{constructor(){super(...arguments),this.collapseSet=new Map,this.userKeysMapping=new Map,this.currFocusIndex=null,this.rowMap=new Map}componentDidMount(){this.props.collapseByDefault&&(Object(u.transaction)((()=>{for(let e=0;e<this.props.types.length;e++)this.onCollapse(`${e}`)})),this.checkAutoScroll())}componentDidUpdate(){this.checkAutoScroll()}onClick(e,t){!this.props.clickable&&t&&this.onCollapse(e);const r=e.split("."),n=e.split(".").reduce(((e,t,n)=>{const s=this.list.find((e=>e.path===r.slice(0,n+1).join(".")));return s?(s.isIndexKey?null==e||e.push({name:this.userKeysMapping.get(s.path)||"0",type:s.type,isIndex:!0,isMapKey:!1}):s.isMapKey?null==e||e.push({name:this.userKeysMapping.get(s.path)||"",type:s.type,isIndex:!1,isMapKey:!0}):null==e||e.push({name:s.name,type:s.type,isIndex:!1,isMapKey:!1}),e):null}),[]);if(n)return this.props.onSelect&&this.props.onSelect(n);pm.logger.warn("TypedefExplorer~onClick - path computation resulted in null. Query = ",e,{context:g})}onCollapse(e){this.collapseSet.has(e)?this.collapseSet.delete(e):this.collapseSet.set(e,!0)}get list(){const{filter:e,types:t,select:r}=this.props,n=t.filter((([e,t])=>e&&t)).filter((([e])=>!r||r===e)),s=[...this.collapseSet.keys()];let i=n.reduce(((e,[t,r],n)=>[...e,...R(t,r||{},0,`${n}`)]),[]);if(e){if(Array.isArray(e)){const t=(e,r,n)=>{if(e.length<=n)return r;const s=r.find((t=>t.path.split(".").length-1===n&&(t.name===e[n]||t.isIndexKey||t.isMapKey)));if(!s)return[];const i=r.reduce(((e,t)=>(t.path.split(".").length<=n&&e.push(t),t.path.startsWith(s.path)&&e.push(t),e)),[]);return t(e,i,n+1)};i=t(e.slice(0,e.length-1),i,0)}else{const t=i.filter((t=>t.name.includes(e))).map((e=>e.path));i=i.filter((e=>t.some((t=>t.startsWith(e.path)||e.path.startsWith(t)))))}return i}return i.filter((({path:e})=>!s.some((t=>t!==e&&e.startsWith(t)))))}setUserKeysMapping(e,t){this.userKeysMapping.set(e,t)}validatePath(e){return this.list.every((({path:t,isMapKey:r})=>!e.startsWith(t)||!r||!!this.userKeysMapping.get(t)))}shouldHighlight(e,t){if(Array.isArray(t)){const r=t[t.length-1];return!!r&&e.startsWith(r)}return e.includes(t)}handleArrowDownKey(e){return null===this.currFocusIndex?(this.currFocusIndex=e||0,!0):this.list.length>this.currFocusIndex+1&&(this.currFocusIndex+=1,!0)}handleArrowUpKey(e){return null===this.currFocusIndex?(this.currFocusIndex=e||this.list.length-1,!0):this.currFocusIndex-1>=0&&(this.currFocusIndex-=1,!0)}clearFocus(){this.currFocusIndex=null}focus(e){var t,r;this.currFocusIndex=e||0,null===(r=(t=this.props).onFocus)||void 0===r||r.call(t,this.currFocusIndex)}handleEnterKey(e){this.list[e]&&this.onClick(this.list[e].path,!!this.list[e].hasChildren)}unCollapseByIndex(e){var t;const r=null===(t=this.list[e])||void 0===t?void 0:t.path;return!(!r||!this.collapseSet.has(r))&&(this.collapseSet.delete(r),!0)}collapseByIndex(e){var t;const r=null===(t=this.list[e])||void 0===t?void 0:t.path;return!(!r||this.collapseSet.has(r))&&(this.collapseSet.set(r,!0),!0)}checkAutoScroll(){if(null===this.currFocusIndex)return;const e=this.rowMap.get(this.currFocusIndex);e&&this.props.container&&Object(d.autoScroll)(e,this.props.container)}render(){const{selectable:e,filter:t,clickable:r}=this.props;return this.list.length?i.a.createElement(p.Flex,{width:"100%",height:"100%",alignItems:"stretch",padding:"spacing-xs",direction:"column"},this.list.map(((n,s)=>{var{path:o}=n,a=T(n,["path"]);return i.a.createElement("div",{onMouseOver:()=>r&&this.focus(s),key:s+o,ref:e=>{this.rowMap.set(s,e)}},i.a.createElement(D,Object.assign({isDisabled:!this.validatePath(o)||!e||0!==e.length&&a.type!==b.Type.ANY&&!e.includes(a.type)},a,{path:o,collapsed:!t&&this.collapseSet.has(o),onClick:this.onClick,onCollapse:this.onCollapse,highlight:!!t&&this.shouldHighlight(a.name,t),updatePathKey:e=>this.setUserKeysMapping(o,e),pathKey:this.userKeysMapping.get(o),isActive:null!==this.currFocusIndex&&this.currFocusIndex===s})))}))):this.props.emptyState?this.props.emptyState:null}};f([u.observable],L.prototype,"collapseSet",void 0),f([u.observable],L.prototype,"userKeysMapping",void 0),f([u.observable],L.prototype,"currFocusIndex",void 0),f([u.action.bound],L.prototype,"onClick",null),f([u.action.bound],L.prototype,"onCollapse",null),f([u.computed],L.prototype,"list",null),f([u.action],L.prototype,"setUserKeysMapping",null),f([u.action],L.prototype,"handleArrowDownKey",null),f([u.action],L.prototype,"handleArrowUpKey",null),f([u.action],L.prototype,"clearFocus",null),f([u.action],L.prototype,"focus",null),f([u.action],L.prototype,"handleEnterKey",null),f([u.action],L.prototype,"unCollapseByIndex",null),f([u.action],L.prototype,"collapseByIndex",null),f([u.action],L.prototype,"checkAutoScroll",null),L=f([n.observer],L),t.default=L},"./flow-runner/components/contextbar/ElementInfoPanelCBView.tsx":function(e,t,r){"use strict";r.r(t);var n=r("../../node_modules/react/index.js"),s=r.n(n),i=r("../../node_modules/mobx-react/dist/mobx-react.module.js"),o=r("../../node_modules/mobx/lib/mobx.module.js"),a=r("../../node_modules/@postman/aether/esmLib/index.js"),p=r("../../node_modules/styled-components/dist/styled-components.browser.esm.js"),c=r("./flow-runner/components/_base/TypeExplorer.tsx"),l=r("./appsdk/contextbar/ContextBarViewHeader.js"),u=function(e,t,r,n){var s,i=arguments.length,o=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,r,n);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(o=(i<3?s(o):i>3?s(t,r,o):s(t,r))||o);return i>3&&o&&Object.defineProperty(t,r,o),o};const y=p.default.div`
  display: flex;
  flex-direction: column;

`,m=Object(p.default)(a.Text)`
  max-width: fit-content;
  min-width: 160px;
  padding: ${({theme:e})=>e["spacing-xs"]} ${({theme:e})=>e["spacing-zero"]};
  cursor: default;
`,h=Object(p.default)(a.Flex)`
  background-color: ${({theme:e})=>e["background-color-secondary"]};
  color: ${({theme:e})=>e["content-color-primary"]};
  font-size: ${({theme:e})=>e["text-size-m"]};
`,d=Object(p.default)(a.Flex)`
    overflow-y: auto;
    padding-bottom: ${({theme:e})=>e["spacing-l"]};
  `,b=Object(p.default)(a.Text)`
    top: 30%;
    padding: 0 ${({theme:e})=>e["spacing-s"]} 0 0;
    margin: 0 0 0 ${({theme:e})=>e["spacing-s"]};
    border-bottom: solid 1px ${({theme:e})=>e["border-color-default"]};
  `;let f=class extends n.Component{constructor(){super(...arguments),this.selectedPort=null,this.focusPort=null}componentDidMount(){const{def:e}=this.props.contextData;e&&(e.input().length?this.setPort("input",e.input()[0].name):e.output().length&&this.setPort("output",e.output()[0].name))}get port(){return this.focusPort||this.selectedPort}setPort(e,t){this.selectedPort=[e,t]}setFocusPort(e,t){this.focusPort=[e,t]}clearFocusPort(){this.focusPort=null}isPort(e,t){return!!this.selectedPort&&this.selectedPort[0]===e&&this.selectedPort[1]===t}render(){const{def:e}=this.props.contextData;return s.a.createElement(d,{direction:"column",height:"100%"},s.a.createElement(l.ContextBarViewHeader,{title:"Input/Output",onClose:this.props.onClose}),e?s.a.createElement(a.Flex,{direction:"column",gap:"spacing-s",padding:"spacing-zero spacing-s"},s.a.createElement(a.Heading,{type:"h5",text:"Input",color:"content-color-primary"}),e.input().map((t=>s.a.createElement(a.Flex,{gap:"spacing-s",direction:"column",key:t.name,padding:"spacing-zero spacing-s"},s.a.createElement(y,null,s.a.createElement(a.Heading,{type:"h5",text:t.friendly,color:"content-color-primary"}),s.a.createElement(m,{type:"para"},t.description)),s.a.createElement(h,null,s.a.createElement(c.default,{types:[...e.inputTypes.entries()],select:t.name,collapseByDefault:!0}))))),s.a.createElement(a.Flex,{gap:"spacing-s",direction:"column",padding:"spacing-zero spacing-s"},s.a.createElement(y,null,s.a.createElement(a.Text,null,"@durable"),s.a.createElement(m,{type:"para"},"This port contains all data that were previously set as durable."))),s.a.createElement(b,null),s.a.createElement(a.Heading,{type:"h5",text:"Output",color:"content-color-primary"}),e.output().map((t=>s.a.createElement(a.Flex,{direction:"column",key:t.name,gap:"spacing-s",padding:"spacing-zero spacing-s"},s.a.createElement(y,null,s.a.createElement(a.Heading,{type:"h5",text:t.friendly,color:"content-color-primary"}),s.a.createElement(m,{type:"para"},t.description)),s.a.createElement(h,null,s.a.createElement(c.default,{types:[...e.outputTypes.entries()],select:t.name,selectable:[],collapseByDefault:!0})))))):s.a.createElement(a.Flex,{direction:"column",padding:"spacing-zero spacing-s"},s.a.createElement(a.Text,{type:"body-medium",color:"content-color-tertiary"},"Click on any block to see its input and output")))}};u([o.observable],f.prototype,"selectedPort",void 0),u([o.observable],f.prototype,"focusPort",void 0),u([o.computed],f.prototype,"port",null),u([o.action],f.prototype,"setPort",null),u([o.action],f.prototype,"setFocusPort",null),u([o.action],f.prototype,"clearFocusPort",null),f=u([i.observer],f),t.default=f},"./flow-runner/merlin-compiler/Expr.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"Grouping",(function(){return i})),r.d(t,"Binary",(function(){return o})),r.d(t,"Unary",(function(){return a})),r.d(t,"Reference",(function(){return p})),r.d(t,"Literal",(function(){return c})),r.d(t,"Sequence",(function(){return l})),r.d(t,"BinarySequence",(function(){return u}));var n=r("./node_modules/json-pointer/index.js"),s=r.n(n);class i{constructor(e){this.path=[],this.expression=e}accept(e){return e.visitGroupingExpr(this)}}class o{constructor(e,t,r,n){this.left=e,this.operator=t,this.right=r,this.path=n}accept(e){return e.visitBinaryExpr(this)}}class a{constructor(e,t,r){this.operator=e,this.child=t,this.path=r}accept(e){return e.visitUnaryExpr(this)}}class p{constructor(e,t){this.value=e,this.path=t}static parse(e){return""===e?[]:"/"!==e.charAt(0)?e.split(/\//).map(s.a.unescape):e.substring(1).split(/\//).map(s.a.unescape)}static compile(e){return s.a.compile(e)}get parsed(){return p.parse(this.value)}accept(e){return e.visitReferenceExpr(this)}}class c{constructor(e,t,r){this.type=t,this.value=e,this.path=r}accept(e){return e.visitLiteralExp(this)}}class l{constructor(e,t){this.path=[],this.expressions=[],this.uniform=t,this.path=e}push(e){this.expressions.push(e)}accept(e){return e.visitSequenceExpr(this)}}class u{constructor(e,t){this.path=[],this.expressions=[],this.uniform=t,this.path=e}push(e,t){this.expressions.push([e,t])}accept(e){return e.visitBinarySequenceExpr(this)}name(e){const t=this.expressions[e];if(t&&t[0]instanceof c&&"string"===t[0].type.type)return t[0].value}}},"./flow-runner/merlin-compiler/operator.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"OpPrecedence",(function(){return n})),r.d(t,"OperatorType",(function(){return s})),r.d(t,"BinOpSymbol",(function(){return i})),r.d(t,"UnOpSymbol",(function(){return o})),r.d(t,"BinOperatorMap",(function(){return c})),r.d(t,"UnOperatorMap",(function(){return l})),r.d(t,"flatOpList",(function(){return u})),r.d(t,"typeCheckBinary",(function(){return y})),r.d(t,"typeCheckUnary",(function(){return m}));var n,s,i,o,a=r("./flow-runner/merlin-types/index.ts"),p=r("./flow-runner/merlin-compiler/value.ts");!function(e){e[e.EQUALITY=0]="EQUALITY",e[e.LOGIC=1]="LOGIC",e[e.COMPARISON=2]="COMPARISON",e[e.TERM=3]="TERM",e[e.FACTOR=4]="FACTOR",e[e.UNARY=5]="UNARY",e[e.DIM=6]="DIM"}(n||(n={})),function(e){e.L_UNARY="lunary",e.R_UNARY="runary",e.BINARY="binary"}(s||(s={})),function(e){e.EQUAL_EQUAL="==",e.NOT_EQUAL="!=",e.LESS="<",e.LESS_EQUAL="<=",e.GREAT=">",e.GREAT_EQUAL=">=",e.IN="in",e.NOT_IN="!in",e.IS="is",e.NOT_IS="!is",e.MATCH="match",e.NOT_MATCH="!match",e.AND="and",e.OR="or",e.SUM="+",e.SUBTRACT="-",e.MULTIPLY="*",e.DIVIDE="/",e.MOD="%",e.EXPONENT="^"}(i||(i={})),function(e){e.NOT="!",e.TO_JSON="to-json",e.LENGTH="len",e.SIZE="size"}(o||(o={}));const c={[i.EQUAL_EQUAL]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"number"},{type:"number"}],[{type:"bool"},{type:"string"},{type:"string"}],[{type:"bool"},{type:"bool"},{type:"bool"}],[{type:"bool"},{type:"timestamp"},{type:"timestamp"}]]},[i.NOT_EQUAL]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"number"},{type:"number"}],[{type:"bool"},{type:"string"},{type:"string"}],[{type:"bool"},{type:"bool"},{type:"bool"}],[{type:"bool"},{type:"timestamp"},{type:"timestamp"}]]},[i.IN]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"string"},{type:"string"}],[{type:"bool"},{type:"string"},{elements:{}}],[{type:"bool"},{type:"number"},{elements:{}}],[{type:"bool"},{type:"bool"},{elements:{}}],[{type:"bool"},{type:"timestamp"},{elements:{}}],[{type:"bool"},{type:"string"},{properties:{}}]]},[i.NOT_IN]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"string"},{type:"string"}],[{type:"bool"},{type:"string"},{elements:{}}],[{type:"bool"},{type:"number"},{elements:{}}],[{type:"bool"},{type:"bool"},{elements:{}}],[{type:"bool"},{type:"timestamp"},{elements:{}}],[{type:"bool"},{type:"string"},{properties:{}}]]},[i.IS]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"string"},{type:"symbol"}],[{type:"bool"},{type:"number"},{type:"symbol"}],[{type:"bool"},{type:"timestamp"},{type:"symbol"}],[{type:"bool"},{type:"regex"},{type:"symbol"}],[{type:"bool"},{type:"bool"},{type:"symbol"}],[{type:"bool"},{elements:{}},{type:"symbol"}],[{type:"bool"},{properties:{}},{type:"symbol"}],[{type:"bool"},{values:{}},{type:"symbol"}],[{type:"bool"},{items:[]},{type:"symbol"}]]},[i.NOT_IS]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"string"},{type:"symbol"}],[{type:"bool"},{type:"number"},{type:"symbol"}],[{type:"bool"},{type:"timestamp"},{type:"symbol"}],[{type:"bool"},{type:"regex"},{type:"symbol"}],[{type:"bool"},{type:"bool"},{type:"symbol"}],[{type:"bool"},{elements:{}},{type:"symbol"}],[{type:"bool"},{properties:{}},{type:"symbol"}],[{type:"bool"},{values:{}},{type:"symbol"}]]},[i.MATCH]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"string"},{type:"regex"}]]},[i.NOT_MATCH]:{type:s.BINARY,category:n.EQUALITY,rules:[[{type:"bool"},{type:"string"},{type:"regex"}]]},[i.LESS]:{type:s.BINARY,category:n.COMPARISON,rules:[[{type:"bool"},{type:"number"},{type:"number"}],[{type:"bool"},{type:"timestamp"},{type:"timestamp"}]]},[i.LESS_EQUAL]:{type:s.BINARY,category:n.COMPARISON,rules:[[{type:"bool"},{type:"number"},{type:"number"}],[{type:"bool"},{type:"timestamp"},{type:"timestamp"}]]},[i.GREAT]:{type:s.BINARY,category:n.COMPARISON,rules:[[{type:"bool"},{type:"number"},{type:"number"}],[{type:"bool"},{type:"timestamp"},{type:"timestamp"}]]},[i.GREAT_EQUAL]:{type:s.BINARY,category:n.COMPARISON,rules:[[{type:"bool"},{type:"number"},{type:"number"}],[{type:"bool"},{type:"timestamp"},{type:"timestamp"}]]},[i.OR]:{type:s.BINARY,category:n.LOGIC,rules:[[{type:"bool"},{type:"bool"},{type:"bool"}]]},[i.AND]:{type:s.BINARY,category:n.LOGIC,rules:[[{type:"bool"},{type:"bool"},{type:"bool"}]]},[i.SUM]:{type:s.BINARY,category:n.TERM,rules:[[{type:"number"},{type:"number"},{type:"number"}],[{type:"string"},{type:"string"},{type:"string"}],[{type:"timestamp"},{type:"timestamp"},{type:"number"}],[{elements:{}},{elements:{}},{elements:{}}],[{items:[]},{items:[]},{items:[]}]]},[i.SUBTRACT]:{type:s.BINARY,category:n.TERM,rules:[[{type:"number"},{type:"number"},{type:"number"}],[{type:"timestamp"},{type:"timestamp"},{type:"number"}]]},[i.MULTIPLY]:{type:s.BINARY,category:n.FACTOR,rules:[[{type:"number"},{type:"number"},{type:"number"}],[{type:"string"},{type:"string"},{type:"number"}]]},[i.DIVIDE]:{type:s.BINARY,category:n.FACTOR,rules:[[{type:"number"},{type:"number"},{type:"number"}]]},[i.MOD]:{type:s.BINARY,category:n.FACTOR,rules:[[{type:"number"},{type:"number"},{type:"number"}]]},[i.EXPONENT]:{type:s.BINARY,category:n.FACTOR,rules:[[{type:"number"},{type:"number"},{type:"number"}]]}},l={[o.NOT]:{type:s.R_UNARY,category:n.UNARY,rules:[[{type:"bool"},{type:"bool"}]]},[o.TO_JSON]:{type:s.L_UNARY,category:n.DIM,rules:[[{type:"string"},{elements:{}}],[{type:"string"},{properties:{}}],[{type:"string"},{items:[]}],[{type:"string"},{values:{}}]]},[o.LENGTH]:{type:s.L_UNARY,category:n.DIM,rules:[[{type:"number"},{type:"string"}],[{type:"number"},{elements:{}}],[{type:"number"},{properties:{}}],[{type:"number"},{items:[]}],[{type:"number"},{values:{}}]]},[o.SIZE]:{type:s.L_UNARY,category:n.DIM,rules:[[{type:"number"},{type:"string"}],[{type:"number"},{elements:{}}],[{type:"number"},{properties:{}}],[{type:"number"},{items:[]}],[{type:"number"},{values:{}}]]}},u=()=>Object.entries(c).reduce(((e,t)=>[...e,{name:t[0],type:t[1].type,rules:t[1].rules,scoped:t[1].scoped}]),[]).concat(Object.entries(l).reduce(((e,t)=>[...e,{name:t[0],type:t[1].type,rules:t[1].rules,scoped:t[1].scoped}]),[])),y=(e,t,r)=>{const{rules:n}=c[e],s=n.filter((([e,r])=>p.ValueHelper.isType(t,r)));if(!(s.length||t instanceof p.MNull))throw new Error(`TypeError: Expected (${t.type}) ${e} to be of type [${n.map((([e,t])=>a.TypeSystem.friendlyName(t))).join(",")}] `);if(!(s.filter((([e,t,n])=>p.ValueHelper.isType(r,n))).length||r instanceof p.MNull))throw new Error(`TypeError: Expected ${t.type} ${e} (${null==r?void 0:r.type}) to be of type [${s.map((([e,t,r])=>a.TypeSystem.friendlyName(r))).join(",")}] `)},m=(e,t)=>{const{rules:r}=l[e];if(!(r.filter((([e,r])=>p.ValueHelper.isType(t,r)))||t instanceof p.MNull))throw new Error(`TypeError: Expected (${t.type}) ${e} to be of type [${r.map((([e,t])=>a.TypeSystem.friendlyName(t))).join(",")}] `)}},"./flow-runner/merlin-compiler/parser.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"SeparatorType",(function(){return n})),r.d(t,"TokenType",(function(){return s})),r.d(t,"Type",(function(){return i})),r.d(t,"ParserError",(function(){return l})),r.d(t,"Parser",(function(){return u}));var n,s,i,o=r("./flow-runner/merlin-compiler/operator.ts"),a=r("./flow-runner/merlin-compiler/Expr.ts"),p=r("./flow-runner/merlin-types/index.ts");!function(e){e.BRACKETOPEN="bracket-open",e.BRACKETCLOSE="bracket-close"}(n||(n={})),function(e){e.OPERATOR="operator",e.LITERAL="literal",e.SEPARATOR="separator",e.REFERENCE="reference",e.FIELD="field",e.NAMEDFIELD="namedfield"}(s||(s={})),function(e){e.SYMBOL="symbol",e.BOOL="bool",e.NUMBER="number",e.REGEX="regex",e.TIME="timestamp",e.STRING="string",e.LIST="list",e.TUPLE="tuple",e.RECORD="record",e.MAP="map",e.ANY="any"}(i||(i={}));const c=e=>[...Object.keys(o.BinOperatorMap).filter((t=>o.BinOperatorMap[t].category===e)),...Object.keys(o.UnOperatorMap).filter((t=>o.UnOperatorMap[t].category===e))].map((e=>[s.OPERATOR,e]));class l extends Error{constructor(e,t){super(e),this.path=t}}class u{constructor(e,t){this.current=0,this.tokens=e,this.path=t}parse(){try{return this.struct()}catch(e){throw this.synchronize(),e}}static parse(e){return new u(e,[]).parse()}struct(){if(this.match([[s.FIELD]])){const e=this.previous,t=new a.Sequence(this.path,"list"===e[2]);return e[1].forEach(((e,r)=>t.push(new u(e,this.path.concat(r)).parse()))),t}if(this.match([[s.NAMEDFIELD]])){const e=this.previous,t=new a.BinarySequence(this.path,"map"===e[2]);return e[1].forEach((([e,r],n)=>t.push(new u(e,this.path.concat(n)).parse(),new u(r,this.path.concat(n)).parse()))),t}return this.expression()}expression(){return this.equality()}equality(){let e=this.logic();for(;this.match(c(o.OpPrecedence.EQUALITY));){const t=this.previous,r=this.prevPath,n=this.logic();e=new a.Binary(e,t[1],n,r)}return e}logic(){let e=this.comparison();for(;this.match(c(o.OpPrecedence.LOGIC));){const t=this.previous,r=this.prevPath,n=this.comparison();e=new a.Binary(e,t[1],n,r)}return e}comparison(){let e=this.term();for(;this.match(c(o.OpPrecedence.COMPARISON));){const t=this.previous,r=this.prevPath,n=this.term();e=new a.Binary(e,t[1],n,r)}return e}term(){let e=this.factor();for(;this.match(c(o.OpPrecedence.TERM));){const t=this.previous,r=this.prevPath,n=this.factor();e=new a.Binary(e,t[1],n,r)}return e}factor(){let e=this.unary();for(;this.match(c(o.OpPrecedence.FACTOR));){const t=this.previous,r=this.prevPath,n=this.unary();e=new a.Binary(e,t[1],n,r)}return e}unary(){if(this.match(c(o.OpPrecedence.UNARY))){const e=this.previous,t=this.prevPath,r=this.unary();return new a.Unary(e[1],r,t)}return this.dim()}dim(){let e=this.primary();if(this.match(c(o.OpPrecedence.DIM))){const t=this.previous,r=this.prevPath;e=new a.Unary(t[1],e,r)}return e}primary(){if(this.match([[s.LITERAL],[s.REFERENCE]]))switch(this.previous[0]){case s.REFERENCE:return new a.Reference(this.previous[1],this.prevPath);case s.LITERAL:return new a.Literal(this.previous[1],p.TypeSystem.inferBasicType(this.previous[2]),this.prevPath);default:throw this.error("Expected a literal or reference",this.peek)}if(this.match([[s.SEPARATOR,"("]])){const e=this.expression();return this.consume(s.SEPARATOR,")","Expected ')' after expression."),new a.Grouping(e)}throw this.error("Couldn't parse the configuration for the block",this.peek)}consume(e,t,r){if(this.check(e,t))return this.advance();throw this.error(r,this.peek)}error(e,t){return new l(e,this.isEnd?this.path:this.path.concat(this.current))}synchronize(){for(this.advance();!this.isEnd;){if(this.peek[0]===s.SEPARATOR&&"("===this.peek[1])return;this.advance()}}match(e){for(const t of e)if(this.check(...t))return this.advance(),!0;return!1}check(e,t){return!this.isEnd&&(t?e===this.peek[0]&&(!t||t===this.peek[1]):e===this.peek[0])}advance(){return this.isEnd||this.current++,this.previous}get isEnd(){return this.current===this.tokens.length}get peek(){return this.tokens[this.current]}get previous(){return this.tokens[this.current-1]}get prevPath(){return this.path.concat(this.current-1)}}},"./flow-runner/merlin-compiler/value.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"MNull",(function(){return s})),r.d(t,"MNumber",(function(){return i})),r.d(t,"MString",(function(){return o})),r.d(t,"MBoolean",(function(){return a})),r.d(t,"MRegex",(function(){return p})),r.d(t,"MDatetime",(function(){return c})),r.d(t,"MFieldStream",(function(){return l})),r.d(t,"MNamedFieldStream",(function(){return u})),r.d(t,"ValueHelper",(function(){return y})),r.d(t,"Structure",(function(){return m}));var n=r("./flow-runner/merlin-types/index.ts");class s{constructor(){this.type="symbol",this.value="null"}static test(e){return"null"===e}length(){return 0}size(){return 0}}class i{constructor(e){this.type="number",this.value=Number(e)}static test(e){return/^-?\d+\.?\d*$/.test(e)}length(){return 1}size(){return 8}}class o{constructor(e){this.type="string",this.value=e}static test(e){return!0}length(){return this.value.length}size(){return new Blob([this.value]).size}}class a{constructor(e){this.type="boolean",this.value=!0===e||"true"===e}static test(e){return"true"===e||"false"===e}length(){return 1}size(){return 1}}class p{constructor(e,t){this.type="regex",this.value=new RegExp(e,t)}static test(e){return e.startsWith("/")&&/\/[igmsuy]*$/.test(e)}length(){return 1}size(){return new Blob([this.value.source]).size}}class c{constructor(e){this.type="timestamp",this.$value="now"===e?"now":new Date(e)}get value(){return"now"===this.$value?Date.now():this.$value.getTime()}static test(e){return"now"===e||/^([0-9]+)-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])[Tt]([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60)(\.[0-9]+)?(([Zz])|([+|-]([01][0-9]|2[0-3]):[0-5][0-9]))$/.test(e)}length(){return 1}size(){return 8}}class l{constructor(e){this.type="list/tuple",this.stream=[],this.stream=e}static is(e){return e instanceof l}get value(){return this.stream.map(((e,t)=>[e,new i(t)]))}length(){return this.stream.length}size(){return this.stream.reduce(((e,t)=>e+t.size()),0)}get(e){return this.stream[e]||new s}set(e,t){this.stream[e]=t}push(e){this.stream.push(e)}map(e){return this.stream.map(((t,r)=>e(t,void 0,r)))}filter(e){return this.stream.filter(((t,r)=>e(t,void 0,r)))}values(){return this.stream}keys(){return[...Array(this.stream.length).keys()]}clear(){this.stream=[]}}class u{constructor(e){this.type="record/dict",this.stream=[],this.names=new Map,this.stream=e.map((([e,t],r)=>(this.names.set(e,r),t)))}get value(){return[...this.names.entries()].map((([e,t])=>[this.stream[t],new o(e)]))}length(){return this.names.size}size(){return[...this.names.entries()].reduce(((e,[t,r])=>e+new o(t).size()+this.stream[r].size()),0)}has(e){return this.names.has(e)}get(e){const t=this.names.get(e);return null==t?new s:this.stream[t]||new s}set(e,t){const r=this.names.get(e);if(null==r)return this.names.set(e,this.stream.length),void this.stream.push(t);this.stream[r]=t}map(e){return[...this.names.entries()].map((([t,r],n)=>e(this.stream[r],t,n)))}filter(e){return[...this.names.entries()].filter((([t,r],n)=>e(this.stream[r],t,n))).map((([e,t])=>[e,this.stream[t]]))}values(){return[...this.names.values()].map((e=>this.stream[e]))}keys(){return[...this.names.keys()]}static merge(e,t){return new u([...e.filter((()=>!0)),...t.filter((()=>!0))])}}class y{static buildValue(e,t){switch(e.type){case"symbol":if("null"===t)return new s;case"bool":return new a(t);case"number":return new i(t);case"regex":{const e=t.lastIndexOf("/");return e!==t.length-1?new p(t.substring(1,e),t.substring(e)):new p(t.slice(1,-1))}case"timestamp":return new c(t);case"string":return new o(t);default:throw new Error(`Could not build value with data type ${e}`)}}static isType(e,t){return!!(e instanceof s&&Object(n.isBasicType)(t)&&"symbol"===t.type)||(!!(e instanceof a&&Object(n.isBasicType)(t)&&"bool"===t.type)||(!!(e instanceof i&&Object(n.isBasicType)(t)&&"number"===t.type)||(!!(e instanceof p&&Object(n.isBasicType)(t)&&"regex"===t.type)||(!!(e instanceof c&&Object(n.isBasicType)(t)&&"timestamp"===t.type)||(!!(e instanceof o&&Object(n.isBasicType)(t)&&"string"===t.type)||(!!(e instanceof l&&(Object(n.isListType)(t)||Object(n.isTupleType)(t)))||!!(e instanceof u&&(Object(n.isRecordType)(t)||Object(n.isDictType)(t)))))))))}}class m{static fromJS(e){if(Array.isArray(e))return new l(e.map(m.fromJS));switch(typeof e){case"bigint":case"number":return new i(e.toString());case"string":return new o(e);case"boolean":return new a(e);case"object":if(null!==e)return e instanceof Date?new c(e.toDateString()):new u(Object.entries(e).map((([e,t])=>[e,m.fromJS(t)])));default:return new s}}static toJS(e){return e instanceof i||e instanceof o||e instanceof a||e instanceof c||e instanceof p?e.value:e instanceof s?null:e instanceof l?e.map(m.toJS):e instanceof u?e.map(((e,t)=>[t,m.toJS(e)])).reduce(((e,[t,r])=>Object.assign(Object.assign({},e),{[t]:r})),{}):void 0}static parseJSON(e){return JSON.parse(e,((e,t)=>{if(Array.isArray(t))return new l(t);switch(typeof t){case"bigint":case"number":return new i(t.toString());case"string":return new o(t);case"boolean":return new a(t);case"object":if(null!==t)return new u(Object.entries(t));default:return new s}}))}}},"./flow-runner/merlin-types/index.ts":function(e,t,r){"use strict";r.r(t);r("./flow-runner/merlin-types/schema.ts");var n=r("./flow-runner/merlin-types/type-checks.ts");r.d(t,"isAnyType",(function(){return n.isAnyType})),r.d(t,"isBasicType",(function(){return n.isBasicType})),r.d(t,"isListType",(function(){return n.isListType})),r.d(t,"isTupleType",(function(){return n.isTupleType})),r.d(t,"isRecordType",(function(){return n.isRecordType})),r.d(t,"isDictType",(function(){return n.isDictType})),r.d(t,"isDiscriminatorType",(function(){return n.isDiscriminatorType})),r.d(t,"isProductType",(function(){return n.isProductType})),r.d(t,"isVariantType",(function(){return n.isVariantType})),r.d(t,"isVariableType",(function(){return n.isVariableType}));var s=r("./flow-runner/merlin-types/type-system.ts");r.d(t,"TypeSystem",(function(){return s.TypeSystem}));var i=r("./flow-runner/merlin-types/type-evaluator.ts");r.d(t,"TypeError",(function(){return i.TypeError})),r.d(t,"TypeEnvironment",(function(){return i.TypeEnvironment})),r.d(t,"TypeEvaluator",(function(){return i.TypeEvaluator}))},"./flow-runner/merlin-types/schema.ts":function(e,t,r){"use strict";r.r(t)},"./flow-runner/merlin-types/type-checks.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"isAnyType",(function(){return s})),r.d(t,"isBasicType",(function(){return i})),r.d(t,"isListType",(function(){return o})),r.d(t,"isTupleType",(function(){return a})),r.d(t,"isRecordType",(function(){return p})),r.d(t,"isDictType",(function(){return c})),r.d(t,"isDiscriminatorType",(function(){return l})),r.d(t,"isProductType",(function(){return u})),r.d(t,"isVariantType",(function(){return y})),r.d(t,"isVariableType",(function(){return m}));var n=function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var s=0;for(n=Object.getOwnPropertySymbols(e);s<n.length;s++)t.indexOf(n[s])<0&&Object.prototype.propertyIsEnumerable.call(e,n[s])&&(r[n[s]]=e[n[s]])}return r};function s(e){const{alias:t,nullable:r,metadata:s}=e,i=n(e,["alias","nullable","metadata"]);return 0===Object.keys(i).length}function i(e){return"type"in e}function o(e){return"elements"in e}function a(e){return"items"in e}function p(e){return"properties"in e}function c(e){return"values"in e}function l(e){return"discriminator"in e}function u(e){return"product"in e}function y(e){return"variants"in e}function m(e){return"variable"in e}},"./flow-runner/merlin-types/type-evaluator.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"TypeError",(function(){return a})),r.d(t,"TypeEnvironment",(function(){return p})),r.d(t,"TypeEvaluator",(function(){return c}));var n=r("./flow-runner/merlin-types/index.ts"),s=r("./flow-runner/merlin-compiler/operator.ts"),i=r("./flow-runner/merlin-compiler/parser.ts"),o=r("./flow-runner/merlin-types/type-checks.ts");class a extends Error{constructor(e,t){super(e),this.path=t}}class p{constructor(){this.types=new Map}define(e,t){this.types.set(e,t)}resolve(e){const[t,...r]=e.parsed,s=this.types.get(t);return s?r.length?n.TypeSystem.resolve(r,s):s:{}}get(e){return this.types.get(e)||{}}has(e){return this.types.has(e)}clear(){this.types.clear()}}class c{constructor(e){this.errors=[],this.environment=e}evaluate(e){this.errors=[];const t=i.Parser.parse(e);return this.$evaluate(t)}resolve(e){return this.evaluate([[i.TokenType.REFERENCE,e,i.Type.ANY]])}$evaluate(e){return e.accept(this)}error(e,t){this.errors.push(new a(e,t))}visitLiteralExp(e){return e.type}visitUnaryExpr(e){const t=s.UnOperatorMap[e.operator];if(!t)return this.error(`Unknown operator ${e.operator}`,e.path),{};const r=this.$evaluate(e.child),i=t.rules.find((([e,t])=>n.TypeSystem.equivalent(t,r)));return i?i[0]:(this.error(`Operand should be "${t.rules.map((([e,t])=>n.TypeSystem.friendlyName(t))).join("/")}" instead of "${r}"`,e.child.path),{})}visitBinaryExpr(e){const t=s.BinOperatorMap[e.operator];if(!t)return this.error(`Unknown operator ${e.operator}`,e.path),{};const r=this.$evaluate(e.left),i=this.$evaluate(e.right),o=t.rules.filter((([e,t])=>n.TypeSystem.equivalent(t,r)));if(!o.length)return this.error(`Operand should be "${t.rules.map((([e,t])=>n.TypeSystem.friendlyName(t))).join("/")}" instead of "${n.TypeSystem.friendlyName(r)}"`,e.left.path),{};const a=o.find((([e,t,r])=>n.TypeSystem.equivalent(r,i)));return a?a[0]:(this.error(`Operand should be "${o.map((([e,t,r])=>n.TypeSystem.friendlyName(r))).join("/")}" instead of "${n.TypeSystem.friendlyName(i)}"`,e.right.path),{})}visitGroupingExpr(e){return this.$evaluate(e.expression)}visitReferenceExpr(e){return this.environment.resolve(e)}visitSequenceExpr(e){if(e.uniform){const t=e.expressions.map((e=>this.$evaluate(e))),r=t.find((e=>!Object(o.isAnyType)(e)));return r&&t.forEach(((t,s)=>{n.TypeSystem.equivalent(r,t)||this.error(`Element should be "${n.TypeSystem.friendlyName(r)}" instead of "${n.TypeSystem.friendlyName(t)}"`,e.path.concat(s))})),e.expressions.length?{elements:r||{}}:{}}return{items:e.expressions.map((e=>this.$evaluate(e)))}}visitBinarySequenceExpr(e){if(e.uniform){const t=e.expressions.map((e=>this.$evaluate(e[1]))),r=t.find((e=>!Object(o.isAnyType)(e)));return r&&t.forEach(((t,s)=>{n.TypeSystem.equivalent(r,t)||this.error(`Value should be "${n.TypeSystem.friendlyName(r)}" instead of "${n.TypeSystem.friendlyName(t)}"`,e.path.concat(s))})),e.expressions.length?{values:r||{}}:{}}return{properties:e.expressions.reduce(((t,[r,n],s)=>{const i=e.name(s);return i?Object.assign(Object.assign({},t),{[i]:this.$evaluate(n)}):t}),{})}}}},"./flow-runner/merlin-types/type-system.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"TypeSystem",(function(){return c}));var n=r("./node_modules/lodash/lodash.js"),s=r("./flow-runner/merlin-compiler/parser.ts"),i=r("./flow-runner/merlin-types/type-checks.ts");const o={symbol:0,bool:1,number:2,string:3,timestamp:4,regex:5},a=[[1,0,0,0,0,0],[0,1,0,0,0,0],[0,0,1,0,0,0],[1,1,1,1,1,1],[0,0,0,0,1,0],[0,0,0,0,0,1]],p=[[1,0,0,0,0,0],[0,1,0,0,0,0],[0,0,1,0,0,0],[0,0,0,1,0,0],[0,0,0,0,1,0],[0,0,0,0,0,1]];class c{static friendlyName(e,t=!1){return Object(i.isBasicType)(e)?Object(n.capitalize)(e.type):Object(i.isListType)(e)?t?"List[]":`List[${c.friendlyName(e.elements,!0)}]`:Object(i.isTupleType)(e)?t?"Tuple[]":`Tuple[${e.items.map((e=>c.friendlyName(e,!0))).join(",")}]`:Object(i.isRecordType)(e)?"Record{}":Object(i.isDictType)(e)?t?"Dictionary{}":`Dictionary{${c.friendlyName(e.values,!0)}}`:Object(i.isDiscriminatorType)(e)?c.friendlyName(c.reduceDiscriminator(e,c.or)):Object(i.isProductType)(e)?t?"...&...":`(${e.product.map((e=>c.friendlyName(e,!0))).join(" & ")} )`:Object(i.isVariantType)(e)?t?"...|...":`(${e.variants.map((e=>c.friendlyName(e,!0))).join(" | ")} )`:Object(i.isVariableType)(e)?e.variable:"∅"}static inferBasicType(e){switch(e){case s.Type.SYMBOL:return{type:"symbol"};case s.Type.NUMBER:return{type:"number"};case s.Type.BOOL:return{type:"bool"};case s.Type.TIME:return{type:"timestamp"};case s.Type.REGEX:return{type:"regex"};case s.Type.STRING:default:return{type:"string"}}}static reduceDiscriminator(e,t){const r=t(Object.values(e.mapping).map((({properties:t})=>({properties:Object.assign(Object.assign({},t),{[e.discriminator]:{type:"string"}})}))));return Object(i.isRecordType)(r)?r:{properties:{}}}static inferJS(e){switch(typeof e){case"string":return{type:"string"};case"bigint":case"number":return{type:"number"};case"boolean":return{type:"bool"};case"object":{if(null===e)return{};if(e instanceof Date)return{type:"timestamp"};if(e instanceof RegExp)return{type:"regex"};if(Array.isArray(e)){if(!e.length||e.every((e=>null===e)))return{items:[]};const t=[],r=r=>(!t[r]&&(t[r]=c.inferJS(e[r])),t[r]);for(let t=0,n=0;t<e.length;t++){const s=r(t);if(Object(i.isAnyType)(s))continue;if(!(0===t||c.equivalent(r(n),r(t),!0)||c.equivalent(r(t),r(n),!0)))return{items:e.map(((e,t)=>r(t)))};n=t}return{elements:t.find((e=>Object(i.isBasicType)(e)))||c.or(t.filter((e=>!Object(i.isAnyType)(e))))}}const t=Object.entries(e).reduce(((e,[t,r])=>Object.assign(Object.assign({},e),{[t]:c.inferJS(r)})),{});return Object.keys(t).length>15&&Object.values(t).every((e=>!(Object(i.isRecordType)(e)||Object(i.isDictType)(e))))&&Object.values(t).every(((e,t,r)=>t===r.length-1||c.equivalent(e,r[t+1],!0)))?{values:c.or(Object.values(t))}:{properties:t}}default:return{}}}static equivalent(e,t,r=!0){if(r&&e.alias&&t.alias&&e.alias!==t.alias)return!1;if(Object(i.isDiscriminatorType)(e)&&Object(i.isDiscriminatorType)(t)&&e.discriminator===t.discriminator)return Object.entries(e.mapping).every((([e,n])=>c.equivalent(n,t.mapping[e]||c.reduceDiscriminator(t,c.and),r)));if(Object(i.isDiscriminatorType)(e))return c.equivalent(c.reduceDiscriminator(e,c.or),t,r);if(Object(i.isDiscriminatorType)(t))return c.equivalent(e,c.reduceDiscriminator(t,c.and),r);if(Object(i.isProductType)(e))return c.equivalent(c.or(e.product),t,r);if(Object(i.isProductType)(t))return c.equivalent(e,c.or(t.product),r);if(Object(i.isVariantType)(e)&&Object(i.isVariantType)(t))return t.variants.every((t=>e.variants.some((e=>c.equivalent(e,t,r)))));if(Object(i.isVariantType)(e))return e.variants.some((e=>c.equivalent(e,t,r)));if(Object(i.isVariantType)(t))return c.equivalent(e,c.and(t.variants),r);if(Object(i.isVariableType)(e)&&Object(i.isVariableType)(t))return e.variable===t.variable;if(Object(i.isVariableType)(e))return!0;if(Object(i.isBasicType)(e)&&Object(i.isBasicType)(t))return r?!!p[o[e.type]][o[t.type]]:!!a[o[e.type]][o[t.type]];if(Object(i.isTupleType)(e)&&Object(i.isTupleType)(t)){if(e.items.length!==t.items.length)return!1;for(let n=0;n<e.items.length;n++)if(!c.equivalent(e.items[n],t.items[n],r))return!1;return!0}return Object(i.isListType)(e)&&Object(i.isListType)(t)?c.equivalent(e.elements,t.elements,r):Object(i.isListType)(e)&&Object(i.isTupleType)(t)?t.items.every((t=>c.equivalent(e.elements,t,r))):Object(i.isDictType)(e)&&Object(i.isDictType)(t)?c.equivalent(e.values,t.values,r):Object(i.isDictType)(e)&&Object(i.isListType)(t)?c.equivalent(e.values,t.elements,r):Object(i.isDictType)(e)&&Object(i.isRecordType)(t)?!(Object(i.isAnyType)(t.properties)&&!Object(i.isAnyType)(e.values))&&Object.values(t.properties).every((t=>c.equivalent(e.values,t,r))):Object(i.isRecordType)(e)&&Object(i.isRecordType)(t)?Object.entries(e.properties).every((([e,n])=>c.equivalent(n,t.properties[e]||{},r))):!!Object(i.isAnyType)(e)}static resolve(e,t){return t?e.reduce(((e,t)=>(Object(i.isDiscriminatorType)(e)&&(e=Object.values(e.mapping)[0]),Number.isInteger(Number(t))&&Object(i.isListType)(e)?e.elements:Object(i.isDictType)(e)?e.values:Object(i.isRecordType)(e)&&e.properties&&e.properties[t]?e.properties[t]:{})),t):{}}static and([e,...t]){if(!t.length)return e;const r=c.and(t);if(Object(i.isBasicType)(e)&&Object(i.isBasicType)(r))return c.equivalent(e,r,!0)?e:{};if(Object(i.isListType)(e)&&Object(i.isListType)(r))return{elements:c.and([e.elements,r.elements])};if(Object(i.isTupleType)(e)&&Object(i.isTupleType)(r)){const[t,n]=e.items.length>r.items.length?[e,r]:[r,e];return{items:n.items.map(((e,r)=>c.and([e,t.items[r]])))}}if(Object(i.isRecordType)(e)&&Object(i.isRecordType)(r)){const t=Object(n.intersection)(Object.keys(e.properties),Object.keys(r.properties)),s=e.properties,i=r.properties;return{properties:t.reduce(((e,t)=>Object.assign(Object.assign({},e),{[t]:c.and([s[t],i[t]])})),{})}}if(Object(i.isDictType)(e)&&Object(i.isDictType)(r))return{values:c.and([e.values,r.values])};if(Object(i.isDiscriminatorType)(e)&&Object(i.isDiscriminatorType)(r)){if(e.discriminator===r.discriminator){const t=Object(n.intersection)(Object.keys(e.mapping),Object.keys(r.mapping));return{discriminator:e.discriminator,mapping:t.reduce(((t,n)=>{const s=c.and([e.mapping[n],r.mapping[n]]);return Object.assign(Object.assign({},t),{[n]:Object(i.isRecordType)(s)?s:{properties:{}}})}),{})}}const t=Object.values(e.mapping).map((({properties:t})=>({properties:Object.assign(Object.assign({},t),{[e.discriminator]:{type:"string"}})}))),s=Object.values(r.mapping).map((({properties:e})=>({properties:Object.assign(Object.assign({},e),{[r.discriminator]:{type:"string"}})})));return c.and([...t,...s])}if(Object(i.isProductType)(e)&&Object(i.isProductType)(r))return c.and([c.or(e.product),c.or(r.product)]);if(Object(i.isVariantType)(e)&&Object(i.isVariantType)(r))return{variants:e.variants.filter((e=>r.variants.some((t=>c.equivalent(e,t,!0)))))};if(Object(i.isVariableType)(e)&&Object(i.isVariableType)(r))return e.variable===r.variable?e:{};const s=(e,t)=>{if(Object(i.isVariantType)(e))return{variants:e.variants.filter((e=>c.equivalent(e,t,!0)))};if(Object(i.isVariableType)(e))return{};if(Object(i.isBasicType)(e)&&Object(i.isAnyType)(t))return e;if(Object(i.isListType)(e)&&Object(i.isTupleType)(t))return{items:t.items.map((t=>c.and([t,e.elements])))};if(Object(i.isRecordType)(t)&&Object(i.isDictType)(e)){return{properties:Object.entries(t.properties).reduce(((t,[r,n])=>Object.assign(Object.assign({},t),{[r]:c.and([n,e.values])})),{})}}if(Object(i.isRecordType)(e)&&Object(i.isDiscriminatorType)(t)&&e.properties[t.discriminator])return{discriminator:t.discriminator,mapping:Object.entries(t.mapping).reduce(((t,[r,n])=>{const s=c.and([n,e]);return Object(i.isRecordType)(s)&&(t[r]=s),t}),{})};if((Object(i.isDictType)(e)||Object(i.isRecordType)(e))&&Object(i.isDiscriminatorType)(t)){const r=Object.values(t.mapping).map((({properties:e})=>({properties:Object.assign(Object.assign({},e),{[t.discriminator]:{type:"string"}})})));return c.and([e,...r])}return Object(i.isProductType)(t)?c.and([e,c.or(t.product)]):Object(i.isAnyType)(e)?t:void 0};return s(e,r)||s(r,e)||{}}static or([e,...t]){if(!t.length)return e;const r=c.or(t);if(Object(i.isBasicType)(e)&&Object(i.isBasicType)(r))return c.equivalent(e,r,!0)?e:{variants:[e,r]};if(Object(i.isListType)(e)&&Object(i.isListType)(r))return{elements:c.or([e.elements,r.elements])};if(Object(i.isTupleType)(e)&&Object(i.isTupleType)(r)){const[t,n]=e.items.length>r.items.length?[e,r]:[r,e];return{items:t.items.map(((e,t)=>c.or([e,n.items[t]||{}])))}}if(Object(i.isRecordType)(e)&&Object(i.isRecordType)(r)){const t=new Set([...Object.keys(e.properties),...Object.keys(r.properties)]),n=e.properties,s=r.properties;return{properties:[...t.values()].reduce(((e,t)=>Object.assign(Object.assign({},e),{[t]:c.or([n[t]||{},s[t]||{}])})),{})}}if(Object(i.isDictType)(e)&&Object(i.isDictType)(r))return{values:c.or([e.values,r.values])};if(Object(i.isDiscriminatorType)(e)&&Object(i.isDiscriminatorType)(r)){if(e.discriminator===r.discriminator){const t=new Set([...Object.keys(e.mapping),...Object.keys(r.mapping)]);return{discriminator:e.discriminator,mapping:[...t.values()].reduce(((t,n)=>{const s=c.or([e.mapping[n]||{},r.mapping[n]||{}]);return Object.assign(Object.assign({},t),{[n]:Object(i.isRecordType)(s)?s:{properties:{}}})}),{})}}const t=c.reduceDiscriminator(e,c.or),n=c.reduceDiscriminator(r,c.or);return c.equivalent(t,n)?c.or([t,n]):{variants:[e,r]}}if(Object(i.isProductType)(e)&&Object(i.isProductType)(r))return c.or([...e.product,...r.product]);if(Object(i.isVariantType)(e)&&Object(i.isVariantType)(r)){const t=r.variants.filter((t=>!e.variants.some((e=>c.equivalent(e,t,!0)))));return{variants:[...e.variants,...t]}}if(Object(i.isVariableType)(e)&&Object(i.isVariableType)(r))return e.variable===r.variable?e:{variants:[e,r]};const n=(e,t)=>{if(Object(i.isListType)(e)&&Object(i.isTupleType)(t))return{elements:c.or([e.elements,...t.items])};if(Object(i.isRecordType)(e)&&Object(i.isDiscriminatorType)(t)){if(e.properties[t.discriminator])return{discriminator:t.discriminator,mapping:Object.entries(t.mapping).reduce(((t,[r,n])=>{const s=c.or([n,e]);return Object(i.isRecordType)(s)?t[r]=s:t[r]=n,t}),{})};const r=Object.values(t.mapping).map((({properties:e})=>({properties:Object.assign(Object.assign({},e),{[t.discriminator]:{type:"string"}})})));return c.or([e,...r])}return Object(i.isTupleType)(e)&&Object(i.isDictType)(t)||Object(i.isListType)(e)&&Object(i.isDictType)(t)||Object(i.isDictType)(e)&&Object(i.isDiscriminatorType)(t)||Object(i.isTupleType)(e)&&Object(i.isDiscriminatorType)(t)||Object(i.isListType)(e)&&Object(i.isDiscriminatorType)(t)||Object(i.isTupleType)(e)&&Object(i.isRecordType)(t)||Object(i.isListType)(e)&&Object(i.isRecordType)(t)||Object(i.isDictType)(e)&&Object(i.isRecordType)(t)?{variants:[e,t]}:Object(i.isProductType)(e)?c.or([...e.product,t]):Object(i.isVariantType)(e)?(e.variants.some((e=>c.equivalent(e,t,!0)))||e.variants.push(r),e):!Object(i.isVariableType)(e)&&!Object(i.isBasicType)(e)||Object(i.isAnyType)(t)?void 0:{variants:[e,t]}};return n(e,r)||n(r,e)||Object(i.isAnyType)(r)&&e||r}}},"./node_modules/foreach/index.js":function(e,t){var r=Object.prototype.hasOwnProperty,n=Object.prototype.toString;e.exports=function(e,t,s){if("[object Function]"!==n.call(t))throw new TypeError("iterator must be a function");var i=e.length;if(i===+i)for(var o=0;o<i;o++)t.call(s,e[o],o,e);else for(var a in e)r.call(e,a)&&t.call(s,e[a],a,e)}},"./node_modules/json-pointer/index.js":function(e,t,r){"use strict";var n=r("./node_modules/foreach/index.js");function s(e,t,r){if(3===arguments.length)return s.set(e,t,r);if(2===arguments.length)return s.get(e,t);var n=s.bind(s,e);for(var i in s)s.hasOwnProperty(i)&&(n[i]=s[i].bind(n,e));return n}e.exports=s,s.get=function(e,t){for(var r=Array.isArray(t)?t:s.parse(t),n=0;n<r.length;++n){var i=r[n];if("object"!=typeof e||!(i in e))throw new Error("Invalid reference token: "+i);e=e[i]}return e},s.set=function(e,t,r){var n=Array.isArray(t)?t:s.parse(t),i=n[0];if(0===n.length)throw Error("Can not set the root object");for(var o=0;o<n.length-1;++o){var a=n[o];"__proto__"!==a&&"constructor"!==a&&"prototype"!==a&&("-"===a&&Array.isArray(e)&&(a=e.length),i=n[o+1],a in e||(i.match(/^(\d+|-)$/)?e[a]=[]:e[a]={}),e=e[a])}return"-"===i&&Array.isArray(e)&&(i=e.length),e[i]=r,this},s.remove=function(e,t){var r=Array.isArray(t)?t:s.parse(t),n=r[r.length-1];if(void 0===n)throw new Error('Invalid JSON pointer for remove: "'+t+'"');var i=s.get(e,r.slice(0,-1));if(Array.isArray(i)){var o=+n;if(""===n&&isNaN(o))throw new Error('Invalid array index: "'+n+'"');Array.prototype.splice.call(i,o,1)}else delete i[n]},s.dict=function(e,t){var r={};return s.walk(e,(function(e,t){r[t]=e}),t),r},s.walk=function(e,t,r){var i=[];r=r||function(e){var t=Object.prototype.toString.call(e);return"[object Object]"===t||"[object Array]"===t},function e(o){n(o,(function(n,o){i.push(String(o)),r(n)?e(n):t(n,s.compile(i)),i.pop()}))}(e)},s.has=function(e,t){try{s.get(e,t)}catch(e){return!1}return!0},s.escape=function(e){return e.toString().replace(/~/g,"~0").replace(/\//g,"~1")},s.unescape=function(e){return e.replace(/~1/g,"/").replace(/~0/g,"~")},s.parse=function(e){if(""===e)return[];if("/"!==e.charAt(0))throw new Error("Invalid JSON pointer: "+e);return e.substring(1).split(/\//).map(s.unescape)},s.compile=function(e){return 0===e.length?"":"/"+e.map(s.escape).join("/")}}}]);